diff -urN ../VisualBoyAdvance-1.7.2/win32/dependencies/cximage/ximalpha.cpp ./win32/dependencies/cximage/ximalpha.cpp
--- ../VisualBoyAdvance-1.7.2/win32/dependencies/cximage/ximalpha.cpp	1970-01-01 09:00:00 +0900
+++ ./win32/dependencies/cximage/ximalpha.cpp	2006-08-24 07:16:03 +0900
@@ -0,0 +1,321 @@
+// xImalpha.cpp : Alpha channel functions
+/* 07/08/2001 v1.00 - Davide Pizzolato - www.xdp.it
+ * CxImage version 5.99c 17/Oct/2004
+ */
+
+#include "ximage.h"
+
+#if CXIMAGE_SUPPORT_ALPHA
+
+////////////////////////////////////////////////////////////////////////////////
+/**
+ * \sa AlphaSetMax
+ */
+BYTE CxImage::AlphaGetMax() const
+{
+	return info.nAlphaMax;
+}
+////////////////////////////////////////////////////////////////////////////////
+/**
+ * Sets global Alpha (opacity) value applied to the whole image,
+ * valid only for painting functions.
+ * \param nAlphaMax: can be from 0 to 255
+ */
+void CxImage::AlphaSetMax(BYTE nAlphaMax)
+{
+	info.nAlphaMax=nAlphaMax;
+}
+////////////////////////////////////////////////////////////////////////////////
+/**
+ * Checks if the image has a valid alpha channel.
+ */
+bool CxImage::AlphaIsValid()
+{
+	return pAlpha!=0;
+}
+////////////////////////////////////////////////////////////////////////////////
+/**
+ * Enables the alpha palette, so the Draw() function changes its behavior.
+ */
+void CxImage::AlphaPaletteEnable(bool enable)
+{
+	info.bAlphaPaletteEnabled=enable;
+}
+////////////////////////////////////////////////////////////////////////////////
+/**
+ * True if the alpha palette is enabled for painting.
+ */
+bool CxImage::AlphaPaletteIsEnabled()
+{
+	return info.bAlphaPaletteEnabled;
+}
+////////////////////////////////////////////////////////////////////////////////
+/**
+ * Inverts the alpha channel.
+ */
+void CxImage::AlphaClear()
+{
+	if (pAlpha)	memset(pAlpha,0,head.biWidth * head.biHeight);
+}
+////////////////////////////////////////////////////////////////////////////////
+/**
+ * Sets the alpha level for the whole image 
+ */
+void CxImage::AlphaSet(BYTE level)
+{
+	if (pAlpha)	memset(pAlpha,level,head.biWidth * head.biHeight);
+}
+////////////////////////////////////////////////////////////////////////////////
+/**
+ * Allocates an empty (opaque) alpha channel.
+ */
+void CxImage::AlphaCreate()
+{
+	if (pAlpha==NULL) {
+		pAlpha = (BYTE*)malloc(head.biWidth * head.biHeight);
+		if (pAlpha) memset(pAlpha,255,head.biWidth * head.biHeight);
+	}
+}
+////////////////////////////////////////////////////////////////////////////////
+void CxImage::AlphaDelete()
+{
+	if (pAlpha) { free(pAlpha); pAlpha=0; }
+}
+////////////////////////////////////////////////////////////////////////////////
+void CxImage::AlphaInvert()
+{
+	if (pAlpha) {
+		BYTE *iSrc=pAlpha;
+		long n=head.biHeight*head.biWidth;
+		for(long i=0; i < n; i++){
+			*iSrc=(BYTE)~(*(iSrc));
+			iSrc++;
+		}
+	}
+}
+////////////////////////////////////////////////////////////////////////////////
+/**
+ * Imports an existing alpa channel from another image with the same width and height.
+ */
+bool CxImage::AlphaCopy(CxImage &from)
+{
+	if (from.pAlpha == NULL || head.biWidth != from.head.biWidth || head.biHeight != from.head.biHeight) return false;
+	if (pAlpha==NULL) pAlpha = (BYTE*)malloc(head.biWidth * head.biHeight);
+	if (pAlpha==NULL) return false;
+	memcpy(pAlpha,from.pAlpha,head.biWidth * head.biHeight);
+	info.nAlphaMax=from.info.nAlphaMax;
+	return true;
+}
+////////////////////////////////////////////////////////////////////////////////
+/**
+ * Creates the alpha channel from a gray scale image.
+ */
+bool CxImage::AlphaSet(CxImage &from)
+{
+	if (!from.IsGrayScale() || head.biWidth != from.head.biWidth || head.biHeight != from.head.biHeight) return false;
+	if (pAlpha==NULL) pAlpha = (BYTE*)malloc(head.biWidth * head.biHeight);
+	BYTE* src = from.info.pImage;
+	BYTE* dst = pAlpha;
+	if (src==NULL || dst==NULL) return false;
+	for (long y=0; y<head.biHeight; y++){
+		memcpy(dst,src,head.biWidth);
+		dst += head.biWidth;
+		src += from.info.dwEffWidth;
+	}
+	return true;
+}
+////////////////////////////////////////////////////////////////////////////////
+/**
+ * Sets the alpha level for a single pixel 
+ */
+void CxImage::AlphaSet(const long x,const long y,const BYTE level)
+{
+	if (pAlpha && IsInside(x,y)) pAlpha[x+y*head.biWidth]=level;
+}
+////////////////////////////////////////////////////////////////////////////////
+/**
+ * Gets the alpha level for a single pixel 
+ */
+BYTE CxImage::AlphaGet(const long x,const long y)
+{
+	if (pAlpha && IsInside(x,y)) return pAlpha[x+y*head.biWidth];
+	return 0;
+}
+////////////////////////////////////////////////////////////////////////////////
+/**
+ * Returns pointer to alpha data for pixel (x,y).
+ *
+ * \author ***bd*** 2.2004
+ */
+BYTE* CxImage::AlphaGetPointer(const long x,const long y)
+{
+	if (pAlpha && IsInside(x,y)) return pAlpha+x+y*head.biWidth;
+	return 0;
+}
+////////////////////////////////////////////////////////////////////////////////
+/**
+ * Get alpha value without boundscheck (a bit faster). Pixel must be inside the image.
+ *
+ * \author ***bd*** 2.2004
+ */
+BYTE CxImage::BlindAlphaGet(const long x,const long y)
+{
+#ifdef _DEBUG
+	if (!IsInside(x,y) || (pAlpha==0)) throw 0;
+#endif
+	return pAlpha[x+y*head.biWidth];
+}
+////////////////////////////////////////////////////////////////////////////////
+/**
+ * Resets the alpha palette 
+ */
+void CxImage::AlphaPaletteClear()
+{
+	RGBQUAD c;
+	for(WORD ip=0; ip<head.biClrUsed;ip++){
+		c=GetPaletteColor((BYTE)ip);
+		c.rgbReserved=0;
+		SetPaletteColor((BYTE)ip,c);
+	}
+}
+////////////////////////////////////////////////////////////////////////////////
+/**
+ * Checks if the image has a valid alpha palette. 
+ */
+bool CxImage::AlphaPaletteIsValid()
+{
+	RGBQUAD c;
+	for(WORD ip=0; ip<head.biClrUsed;ip++){
+		c=GetPaletteColor((BYTE)ip);
+		if (c.rgbReserved != 0) return true;
+	}
+	return false;
+}
+////////////////////////////////////////////////////////////////////////////////
+/**
+ * Blends the alpha channel and the alpha palette with the pixels. The result is a 24 bit image.
+ * The background color can be selected using SetTransColor().
+ */
+void CxImage::AlphaStrip()
+{
+	bool bAlphaPaletteIsValid = AlphaPaletteIsValid();
+	bool bAlphaIsValid = AlphaIsValid();
+	if (!(bAlphaIsValid || bAlphaPaletteIsValid)) return;
+	RGBQUAD c;
+	long a, a1;
+	if (head.biBitCount==24){
+		for(long y=0; y<head.biHeight; y++){
+			for(long x=0; x<head.biWidth; x++){
+				c=GetPixelColor(x,y);
+				if (bAlphaIsValid) a=(AlphaGet(x,y)*info.nAlphaMax)/255; else a=info.nAlphaMax;
+				a1 = 255-a;
+				c.rgbBlue = (BYTE)((c.rgbBlue * a + a1 * info.nBkgndColor.rgbBlue)/255);
+				c.rgbGreen = (BYTE)((c.rgbGreen * a + a1 * info.nBkgndColor.rgbGreen)/255);
+				c.rgbRed = (BYTE)((c.rgbRed * a + a1 * info.nBkgndColor.rgbRed)/255);
+				SetPixelColor(x,y,c);
+			}
+		}
+		AlphaDelete();
+	} else {
+		CxImage tmp(head.biWidth,head.biHeight,24);
+		if (!tmp.IsValid()) return;
+		for(long y=0; y<head.biHeight; y++){
+			for(long x=0; x<head.biWidth; x++){
+				c=GetPixelColor(x,y);
+				if (bAlphaIsValid) a=(AlphaGet(x,y)*info.nAlphaMax)/255; else a=info.nAlphaMax;
+				if (bAlphaPaletteIsValid) a=(c.rgbReserved*a)/255;
+				a1 = 255-a;
+				c.rgbBlue = (BYTE)((c.rgbBlue * a + a1 * info.nBkgndColor.rgbBlue)/255);
+				c.rgbGreen = (BYTE)((c.rgbGreen * a + a1 * info.nBkgndColor.rgbGreen)/255);
+				c.rgbRed = (BYTE)((c.rgbRed * a + a1 * info.nBkgndColor.rgbRed)/255);
+				tmp.SetPixelColor(x,y,c);
+			}
+		}
+		Transfer(tmp);
+	}
+	return;
+}
+////////////////////////////////////////////////////////////////////////////////
+bool CxImage::AlphaFlip()
+{
+	if (!pAlpha) return false;
+	BYTE* pAlpha2 = (BYTE*)malloc(head.biWidth * head.biHeight);
+	if (!pAlpha2) return false;
+	BYTE *iSrc,*iDst;
+	iSrc=pAlpha + (head.biHeight-1)*head.biWidth;
+	iDst=pAlpha2;
+    for(long y=0; y < head.biHeight; y++){
+		memcpy(iDst,iSrc,head.biWidth);
+		iSrc-=head.biWidth;
+		iDst+=head.biWidth;
+	}
+	free(pAlpha);
+	pAlpha=pAlpha2;
+	return true;
+}
+////////////////////////////////////////////////////////////////////////////////
+bool CxImage::AlphaMirror()
+{
+	if (!pAlpha) return false;
+	BYTE* pAlpha2 = (BYTE*)malloc(head.biWidth * head.biHeight);
+	if (!pAlpha2) return false;
+	BYTE *iSrc,*iDst;
+	long wdt=head.biWidth-1;
+	iSrc=pAlpha + wdt;
+	iDst=pAlpha2;
+	for(long y=0; y < head.biHeight; y++){
+		for(long x=0; x <= wdt; x++)
+			*(iDst+x)=*(iSrc-x);
+		iSrc+=head.biWidth;
+		iDst+=head.biWidth;
+	}
+	free(pAlpha);
+	pAlpha=pAlpha2;
+	return true;
+}
+////////////////////////////////////////////////////////////////////////////////
+/**
+ * Exports the alpha channel in a 8bpp grayscale image. 
+ */
+bool CxImage::AlphaSplit(CxImage *dest)
+{
+	if (!pAlpha || !dest) return false;
+
+	CxImage tmp(head.biWidth,head.biHeight,8);
+	if (!tmp.IsValid()) return false;
+
+	for(long y=0; y<head.biHeight; y++){
+		for(long x=0; x<head.biWidth; x++){
+			tmp.SetPixelIndex(x,y,pAlpha[x+y*head.biWidth]);
+		}
+	}
+
+	tmp.SetGrayPalette();
+	dest->Transfer(tmp);
+
+	return true;
+}
+////////////////////////////////////////////////////////////////////////////////
+/**
+ * Exports the alpha palette channel in a 8bpp grayscale image. 
+ */
+bool CxImage::AlphaPaletteSplit(CxImage *dest)
+{
+	if (!AlphaPaletteIsValid() || !dest) return false;
+
+	CxImage tmp(head.biWidth,head.biHeight,8);
+	if (!tmp.IsValid()) return false;
+
+	for(long y=0; y<head.biHeight; y++){
+		for(long x=0; x<head.biWidth; x++){
+			tmp.SetPixelIndex(x,y,GetPixelColor(x,y).rgbReserved);
+		}
+	}
+
+	tmp.SetGrayPalette();
+	dest->Transfer(tmp);
+
+	return true;
+}
+////////////////////////////////////////////////////////////////////////////////
+#endif //CXIMAGE_SUPPORT_ALPHA
diff -urN ../VisualBoyAdvance-1.7.2/win32/dependencies/cximage/ximalyr.cpp ./win32/dependencies/cximage/ximalyr.cpp
--- ../VisualBoyAdvance-1.7.2/win32/dependencies/cximage/ximalyr.cpp	1970-01-01 09:00:00 +0900
+++ ./win32/dependencies/cximage/ximalyr.cpp	2006-08-24 07:16:03 +0900
@@ -0,0 +1,105 @@
+// xImaLyr.cpp : Layers functions
+/* 21/04/2003 v1.00 - Davide Pizzolato - www.xdp.it
+ * CxImage version 5.99c 17/Oct/2004
+ */
+
+#include "ximage.h"
+
+#if CXIMAGE_SUPPORT_LAYERS
+
+////////////////////////////////////////////////////////////////////////////////
+/**
+ * If the object is an internal layer, GetParent return its parent in the hierarchy.
+ */
+CxImage* CxImage::GetParent() const
+{
+	return info.pParent;
+}
+////////////////////////////////////////////////////////////////////////////////
+/**
+ * Number of layers allocated directly by the object.
+ */
+long CxImage::GetNumLayers() const
+{
+	return info.nNumLayers;
+}
+////////////////////////////////////////////////////////////////////////////////
+/**
+ * Creates an empty layer. If position is less than 0, the new layer will be placed in the last position
+ */
+bool CxImage::LayerCreate(long position)
+{
+	if ( position < 0 || position > info.nNumLayers ) position = info.nNumLayers;
+
+	CxImage** ptmp = (CxImage**)malloc((info.nNumLayers + 1)*sizeof(CxImage**));
+	if (ptmp==0) return false;
+
+	int i=0;
+	for (int n=0; n<info.nNumLayers; n++){
+		if (position == n){
+			ptmp[n] = new CxImage();
+			i=1;
+		}
+		ptmp[n+i]=pLayers[n];
+	}
+	if (i==0) ptmp[info.nNumLayers] = new CxImage();
+
+	if (ptmp[position]){
+		ptmp[position]->info.pParent = this;
+	} else {
+		free(ptmp);
+		return false;
+	}
+
+	info.nNumLayers++;
+	if (pLayers) free(pLayers);
+	pLayers = ptmp;
+	return true;
+}
+////////////////////////////////////////////////////////////////////////////////
+/**
+ * Deletes a layer. If position is less than 0, the last layer will be deleted
+ */
+bool CxImage::LayerDelete(long position)
+{
+	if ( position >= info.nNumLayers ) return false;
+	if ( position < 0) position = info.nNumLayers - 1;
+
+	CxImage** ptmp = (CxImage**)malloc((info.nNumLayers - 1)*sizeof(CxImage**));
+	if (ptmp==0) return false;
+
+	int i=0;
+	for (int n=0; n<(info.nNumLayers - 1); n++){
+		if (position == n){
+			delete pLayers[n];
+			i=1;
+		}
+		ptmp[n]=pLayers[n+i];
+	}
+	if (i==0) delete pLayers[info.nNumLayers - 1];
+
+	info.nNumLayers--;
+	if (pLayers) free(pLayers);
+	pLayers = ptmp;
+	return true;
+}
+////////////////////////////////////////////////////////////////////////////////
+void CxImage::LayerDeleteAll()
+{
+	if (pLayers) { 
+		for(long n=0; n<info.nNumLayers;n++){ delete pLayers[n]; }
+		free(pLayers); pLayers=0;
+	}
+}
+////////////////////////////////////////////////////////////////////////////////
+/**
+ * Returns a pointer to a layer. If position is less than 0, the last layer will be returned
+ */
+CxImage* CxImage::GetLayer(long position)
+{
+	if ( position >= info.nNumLayers ) return 0;
+	if ( position < 0) position = info.nNumLayers - 1;
+	return pLayers[position];
+}
+////////////////////////////////////////////////////////////////////////////////
+#endif //CXIMAGE_SUPPORT_LAYERS
diff -urN ../VisualBoyAdvance-1.7.2/win32/dependencies/cximage/ximamng.cpp ./win32/dependencies/cximage/ximamng.cpp
--- ../VisualBoyAdvance-1.7.2/win32/dependencies/cximage/ximamng.cpp	1970-01-01 09:00:00 +0900
+++ ./win32/dependencies/cximage/ximamng.cpp	2006-08-24 07:16:03 +0900
@@ -0,0 +1,366 @@
+/*
+ * File:	ximamng.cpp
+ * Purpose:	Platform Independent MNG Image Class Loader and Writer
+ * Author:	07/Aug/2001 Davide Pizzolato - www.xdp.it
+ * CxImage version 5.99c 17/Oct/2004
+ */
+
+#include "ximamng.h"
+
+#if CXIMAGE_SUPPORT_MNG
+
+////////////////////////////////////////////////////////////////////////////////
+// callbacks for the mng decoder:
+////////////////////////////////////////////////////////////////////////////////
+
+////////////////////////////////////////////////////////////////////////////////
+// memory allocation; data must be zeroed
+static mng_ptr
+mymngalloc( mng_uint32 size )
+{
+	return (mng_ptr)calloc(1, size);
+}
+
+////////////////////////////////////////////////////////////////////////////////
+// memory deallocation
+static void mymngfree(mng_ptr p, mng_uint32 size)
+{
+	free(p);
+}
+
+////////////////////////////////////////////////////////////////////////////////
+// Stream open/close:
+// since the user is responsible for opening and closing the file,
+// we leave the default implementation open
+static mng_bool mymngopenstream(mng_handle mng)      { return MNG_TRUE; }
+static mng_bool mymngopenstreamwrite(mng_handle mng) { return MNG_TRUE; }
+static mng_bool mymngclosestream(mng_handle mng)     { return MNG_TRUE; }
+
+////////////////////////////////////////////////////////////////////////////////
+// feed data to the decoder
+static mng_bool mymngreadstream(mng_handle mng, mng_ptr buffer, mng_uint32 size, mng_uint32 *bytesread)
+{
+	mngstuff *mymng = (mngstuff *)mng_get_userdata(mng);
+	// read the requested amount of data from the file
+	*bytesread = mymng->file->Read( buffer, sizeof(BYTE), size);
+	return MNG_TRUE;
+}
+
+////////////////////////////////////////////////////////////////////////////////
+static mng_bool mymngwritestream (mng_handle mng, mng_ptr pBuf, mng_uint32 iSize, mng_uint32 *iWritten)
+{
+	mngstuff *mymng = (mngstuff *)mng_get_userdata(mng);
+	// write it
+	*iWritten = mymng->file->Write (pBuf, 1, iSize);
+	return MNG_TRUE;
+}
+
+////////////////////////////////////////////////////////////////////////////////
+// the header's been read. set up the display stuff
+static mng_bool mymngprocessheader( mng_handle mng, mng_uint32 width, mng_uint32 height )
+{
+	// normally the image buffer is allocated here,
+	// but in this module we don't know nothing about
+	// the final environment.
+
+	mngstuff *mymng = (mngstuff *)mng_get_userdata(mng);
+	
+	mymng->width  = width;
+	mymng->height = height;
+	mymng->bpp    = 24;
+	mymng->effwdt = ((((width * mymng->bpp) + 31) >> 5) << 2);
+
+	if (mng->bUseBKGD){
+		mymng->nBkgndIndex = 0;
+		mymng->nBkgndColor.rgbRed  = mng->iBGred >> 8;
+		mymng->nBkgndColor.rgbGreen =mng->iBGgreen >> 8;
+		mymng->nBkgndColor.rgbBlue = mng->iBGblue >> 8;
+	}
+
+	mymng->image = (BYTE*)malloc(height * mymng->effwdt);
+
+	// tell the mng decoder about our bit-depth choice
+	mng_set_canvasstyle( mng, MNG_CANVAS_BGR8 );
+	return MNG_TRUE;
+}
+
+////////////////////////////////////////////////////////////////////////////////
+// return a row pointer for the decoder to fill
+static mng_ptr mymnggetcanvasline( mng_handle mng, mng_uint32 line )
+{
+	mngstuff *mymng = (mngstuff *)mng_get_userdata(mng);
+	return (mng_ptr)(mymng->image + (mymng->effwdt * (mymng->height - 1 - line)));
+}
+
+////////////////////////////////////////////////////////////////////////////////
+// timer
+static mng_uint32 mymnggetticks(mng_handle mng)
+{
+#ifdef WIN32
+	return (mng_uint32)GetTickCount();
+#else
+  return 0;
+#endif
+}
+
+////////////////////////////////////////////////////////////////////////////////
+// Refresh: actual frame need to be updated (Invalidate)
+static mng_bool mymngrefresh(mng_handle mng, mng_uint32 x, mng_uint32 y, mng_uint32 w, mng_uint32 h)
+{
+//	mngstuff *mymng = (mngstuff *)mng_get_userdata(mng);
+	return MNG_TRUE;
+}
+
+////////////////////////////////////////////////////////////////////////////////
+// interframe delay callback
+static mng_bool mymngsettimer(mng_handle mng, mng_uint32 msecs)
+{
+	mngstuff *mymng = (mngstuff *)mng_get_userdata(mng);
+	mymng->delay = msecs; 	// set the timer for when the decoder wants to be woken
+	return MNG_TRUE;
+}
+
+////////////////////////////////////////////////////////////////////////////////
+static mng_bool mymngerror(mng_handle mng, mng_int32 code, mng_int8 severity, mng_chunkid chunktype, mng_uint32 chunkseq, mng_int32 extra1, mng_int32 extra2, mng_pchar text)
+{
+	//throw (const char *)text;
+	return mng_cleanup(&mng); //<Arkadiy Olovyannikov>
+}
+
+////////////////////////////////////////////////////////////////////////////////
+// CxImage members
+////////////////////////////////////////////////////////////////////////////////
+CxImageMNG::CxImageMNG(): CxImage(CXIMAGE_FORMAT_MNG)
+{
+	hmng = NULL;
+	memset(&mnginfo,0,sizeof(mngstuff));
+	mnginfo.nBkgndIndex = -1;
+	mnginfo.speed = 1.0f;
+}
+////////////////////////////////////////////////////////////////////////////////
+CxImageMNG::~CxImageMNG()
+{
+	// cleanup and return
+	if (mnginfo.thread){ //close the animation thread
+		mnginfo.animation_enabled=0;
+		ResumeThread(mnginfo.thread);
+		WaitForSingleObject(mnginfo.thread,500);
+		CloseHandle(mnginfo.thread);
+	}
+	// free objects
+	if (mnginfo.image) free(mnginfo.image);
+	if (hmng) mng_cleanup(&hmng); //be sure it's not needed any more. (active timers ?)
+}
+////////////////////////////////////////////////////////////////////////////////
+void CxImageMNG::SetCallbacks(mng_handle mng)
+{
+	// set the callbacks
+	mng_setcb_errorproc(mng, mymngerror);
+	mng_setcb_openstream(mng, mymngopenstream);
+	mng_setcb_closestream(mng, mymngclosestream);
+	mng_setcb_readdata(mng, mymngreadstream);
+	mng_setcb_processheader(mng, mymngprocessheader);
+	mng_setcb_getcanvasline(mng, mymnggetcanvasline);
+	mng_setcb_refresh(mng, mymngrefresh);
+	mng_setcb_gettickcount(mng, mymnggetticks);
+	mng_setcb_settimer(mng, mymngsettimer);
+	mng_setcb_refresh(mng, mymngrefresh);
+}
+////////////////////////////////////////////////////////////////////////////////
+// can't use the CxImage implementation because it looses mnginfo
+bool CxImageMNG::Load(const char * imageFileName){
+		FILE* hFile;	//file handle to read the image
+		if ((hFile=fopen(imageFileName,"rb"))==NULL)  return false;
+		bool bOK = Decode(hFile);
+		fclose(hFile);
+		return bOK;
+}
+////////////////////////////////////////////////////////////////////////////////
+bool CxImageMNG::Decode(CxFile *hFile)
+{
+	if (hFile == NULL) return false;
+
+	try {
+		// set up the mng decoder for our stream
+		hmng = mng_initialize(&mnginfo, mymngalloc, mymngfree, MNG_NULL);
+		if (hmng == NULL) throw "could not initialize libmng";			
+
+		// set the file we want to play
+		mnginfo.file = hFile;
+
+		// Set the colorprofile, lcms uses this:
+		mng_set_srgb(hmng, MNG_TRUE );
+		// Set white as background color:
+		WORD Red,Green,Blue;
+		Red = Green = Blue = (255 << 8) + 255;
+		mng_set_bgcolor(hmng, Red, Green, Blue );
+		// If PNG Background is available, use it:
+		mng_set_usebkgd(hmng, MNG_TRUE );
+
+		// No need to store chunks:
+		mng_set_storechunks(hmng, MNG_FALSE);
+		// No need to wait: straight reading
+		mng_set_suspensionmode(hmng, MNG_FALSE);
+
+		SetCallbacks(hmng);
+
+		mng_datap pData = (mng_datap)hmng;
+
+		// read in the image
+		info.nNumFrames=0;
+		mng_readdisplay(hmng);
+
+		// read all
+		int retval=MNG_NOERROR;
+		while(pData->bReading){
+			retval = mng_display_resume(hmng);
+			info.nNumFrames++;
+		}
+
+		// single frame check:
+		if (retval != MNG_NEEDTIMERWAIT){
+			info.nNumFrames--;
+		} else {
+			mnginfo.animation=1;
+		}
+
+		if (info.nNumFrames<=0) info.nNumFrames=1;
+
+		if (mnginfo.animation_enabled==0){
+			// select the frame
+			if (info.nFrame>=0 && info.nFrame<info.nNumFrames){
+				for (int n=0;n<info.nFrame;n++) mng_display_resume(hmng);
+			} else throw "Error: frame not present in MNG file";
+		}
+
+		if (mnginfo.nBkgndIndex != -1){
+			info.nBkgndIndex = mnginfo.nBkgndIndex;
+			info.nBkgndColor.rgbRed = mnginfo.nBkgndColor.rgbRed;
+			info.nBkgndColor.rgbGreen = mnginfo.nBkgndColor.rgbGreen;
+			info.nBkgndColor.rgbBlue = mnginfo.nBkgndColor.rgbBlue;
+		}
+
+		//store the newly created image
+		if (Create(mnginfo.width,mnginfo.height,mnginfo.bpp, CXIMAGE_FORMAT_MNG)){
+			memcpy(GetBits(), mnginfo.image, mnginfo.effwdt * mnginfo.height);
+		} else throw "CxImageMNG::Decode cannot create image";
+
+
+	} catch (char *message) {
+		strncpy(info.szLastError,message,255);
+		return false;
+	}
+	return true;
+}
+////////////////////////////////////////////////////////////////////////////////
+bool CxImageMNG::Encode(CxFile *hFile)
+{
+	if (EncodeSafeCheck(hFile)) return false;
+
+	try {
+		if (head.biClrUsed != 0) throw "MNG encoder can save only RGB images";
+		// set the file we want to play
+		mnginfo.file = hFile;
+		mnginfo.bpp = head.biBitCount;
+		mnginfo.effwdt = info.dwEffWidth;
+		mnginfo.height = head.biHeight;
+		mnginfo.width =  head.biWidth;
+
+		mnginfo.image = (BYTE*)malloc(head.biSizeImage);
+		if (mnginfo.image == NULL) throw "could not allocate memory for MNG";
+		memcpy(mnginfo.image,info.pImage, head.biSizeImage);
+
+		// set up the mng decoder for our stream
+		hmng = mng_initialize(&mnginfo, mymngalloc, mymngfree, MNG_NULL);
+		if (hmng == NULL) throw "could not initialize libmng";			
+
+		mng_setcb_openstream(hmng, mymngopenstreamwrite );
+		mng_setcb_closestream(hmng, mymngclosestream);
+		mng_setcb_writedata(hmng, mymngwritestream);
+
+		// Write File:
+   		mng_create(hmng);
+		// Just a single Frame (save a normal PNG):
+		WritePNG(hmng, 0, 1 );
+		// Now write file:
+		mng_write(hmng);
+
+	} catch (char *message) {
+		strncpy(info.szLastError,message,255);
+		return false;
+	}
+	return true;
+}
+////////////////////////////////////////////////////////////////////////////////
+// Writes a single PNG datastream
+void CxImageMNG::WritePNG( mng_handle hMNG, int Frame, int FrameCount )
+{
+	mngstuff *mymng = (mngstuff *)mng_get_userdata(hMNG);
+	
+	int OffsetX=0,OffsetY=0,OffsetW=mymng->width,OffsetH=mymng->height;
+
+	BYTE *tmpbuffer = new BYTE[ (mymng->effwdt+1) * mymng->height];
+	if( tmpbuffer == 0 ) return;
+
+	// Write DEFI chunk.
+	mng_putchunk_defi( hMNG, 0, 0, 0, MNG_TRUE, OffsetX, OffsetY, MNG_FALSE, 0, 0, 0, 0 );
+ 		 
+	// Write Header:
+	mng_putchunk_ihdr(
+		hMNG, 
+		OffsetW, OffsetH, 
+		MNG_BITDEPTH_8, 
+		MNG_COLORTYPE_RGB, 
+		MNG_COMPRESSION_DEFLATE, 
+		MNG_FILTER_ADAPTIVE, 
+		MNG_INTERLACE_NONE 
+	);
+
+	// transfer data, add Filterbyte:
+	for( int Row=0; Row<OffsetH; Row++ ){
+		// First Byte in each Scanline is Filterbyte: Currently 0 -> No Filter.
+		tmpbuffer[Row*(mymng->effwdt+1)]=0; 
+		// Copy the scanline: (reverse order)
+		memcpy(tmpbuffer+Row*(mymng->effwdt+1)+1, 
+			mymng->image+((OffsetH-1-(OffsetY+Row))*(mymng->effwdt))+OffsetX,mymng->effwdt);
+		// swap red and blue components
+		RGBtoBGR(tmpbuffer+Row*(mymng->effwdt+1)+1,mymng->effwdt);
+	} 
+
+	// Compress data with ZLib (Deflate):
+	BYTE *dstbuffer = new BYTE[(mymng->effwdt+1)*OffsetH];
+	if( dstbuffer == 0 ) return;
+	DWORD dstbufferSize=(mymng->effwdt+1)*OffsetH;
+
+	// Compress data:
+	if(Z_OK != compress2((Bytef *)dstbuffer,(ULONG *)&dstbufferSize,(const Bytef*)tmpbuffer,
+						(ULONG) (mymng->effwdt+1)*OffsetH,9 )) return;
+
+	// Write Data into MNG File:
+	mng_putchunk_idat( hMNG, dstbufferSize, (mng_ptr*)dstbuffer);
+	mng_putchunk_iend(hMNG);
+
+	// Free the stuff:
+	delete [] tmpbuffer;
+	delete [] dstbuffer;
+}
+////////////////////////////////////////////////////////////////////////////////
+long CxImageMNG::Resume()
+{
+	if (MNG_NEEDTIMERWAIT == mng_display_resume(hmng)){
+		if (info.pImage==NULL) Create(mnginfo.width,mnginfo.height,mnginfo.bpp, CXIMAGE_FORMAT_MNG);
+		if (IsValid()) memcpy(GetBits(), mnginfo.image, mnginfo.effwdt * mnginfo.height);
+	} else {
+		mnginfo.animation_enabled = 0;
+	}
+	return mnginfo.animation_enabled;
+}
+////////////////////////////////////////////////////////////////////////////////
+void CxImageMNG::SetSpeed(float speed)
+{
+	if (speed>10.0) mnginfo.speed = 10.0f;
+	else if (speed<0.1) mnginfo.speed = 0.1f;
+	else mnginfo.speed=speed;
+}
+////////////////////////////////////////////////////////////////////////////////
+#endif // CXIMAGE_SUPPORT_MNG
diff -urN ../VisualBoyAdvance-1.7.2/win32/dependencies/cximage/ximamng.h ./win32/dependencies/cximage/ximamng.h
--- ../VisualBoyAdvance-1.7.2/win32/dependencies/cximage/ximamng.h	1970-01-01 09:00:00 +0900
+++ ./win32/dependencies/cximage/ximamng.h	2006-08-24 07:16:03 +0900
@@ -0,0 +1,86 @@
+/*
+ * File:	ximamng.h
+ * Purpose:	Declaration of the MNG Image Class
+ * Author:	Davide Pizzolato - www.xdp.it
+ * Created:	2001
+ */
+/* ==========================================================
+ * CxImageMNG (c) 07/Aug/2001 Davide Pizzolato - www.xdp.it
+ * For conditions of distribution and use, see copyright notice in ximage.h
+ *
+ * Special thanks to Frank Haug <f.haug(at)jdm(dot)de> for suggestions and code.
+ *
+ * original mng.cpp code created by Nikolaus Brennig, November 14th, 2000. <virtualnik(at)nol(dot)at>
+ *
+ * LIBMNG Copyright (c) 2000,2001 Gerard Juyn (gerard@libmng.com)
+ * ==========================================================
+ */
+
+#if !defined(__ximaMNG_h)
+#define __ximaMNG_h
+
+#include "ximage.h"
+
+#if CXIMAGE_SUPPORT_MNG
+
+//#define MNG_NO_CMS
+#define MNG_SUPPORT_DISPLAY
+#define MNG_SUPPORT_READ
+#define	MNG_SUPPORT_WRITE
+#define MNG_ACCESS_CHUNKS
+#define MNG_STORE_CHUNKS
+
+extern "C" {
+#include "../mng/libmng.h"
+#include "../mng/libmng_data.h"
+}
+
+//unsigned long _stdcall RunMNGThread(void *lpParam);
+
+typedef struct tagmngstuff 
+{
+	CxFile		*file;
+	BYTE		*image;
+	HANDLE		thread;
+	mng_uint32	delay;
+	mng_uint32  width;
+	mng_uint32  height;
+	mng_uint32  effwdt;
+	mng_int16	bpp;
+	mng_bool	animation;
+	mng_bool	animation_enabled;
+	float		speed;
+	long		nBkgndIndex;
+	RGBQUAD		nBkgndColor;
+} mngstuff;
+
+class CxImageMNG: public CxImage
+{
+public:
+	CxImageMNG();
+	~CxImageMNG();
+
+	bool Load(const char * imageFileName);
+	bool Save(const char * imageFileName){ return CxImage::Save(imageFileName,CXIMAGE_FORMAT_MNG);}
+
+	bool Decode(CxFile * hFile);
+	bool Decode(FILE *hFile) { CxIOFile file(hFile); return Decode(&file); }
+
+#if CXIMAGE_SUPPORT_ENCODE
+	bool Encode(CxFile * hFile);
+	bool Encode(FILE *hFile) { CxIOFile file(hFile); return Encode(&file); }
+#endif // CXIMAGE_SUPPORT_ENCODE
+
+	long Resume();
+	void SetSpeed(float speed);
+	
+	mng_handle hmng;
+	mngstuff mnginfo;
+protected:
+	void WritePNG(mng_handle hMNG, int Frame, int FrameCount );
+	void SetCallbacks(mng_handle mng);
+};
+
+#endif
+
+#endif
